;program KZ_TX203 (88 byte) PPGM F7-FF, PRG 1B1-1FE
;progr.: OSC-LP, WD-OFF, CP-OFF, MCLR-INT
 list       F=inhx8m, P=12C508A, R=hex, N=0

indf    equ     0x00
status  equ     0x03
fsr     equ     0x04
gpio    equ     0x06

znak_1	equ	0xAA	;DEFINOVAT 32bit KOD,
znak_2	equ	0x47	;SHODNY S PRIJIMACEM
znak_3	equ	0xA3
znak_4	equ	0x36

;registry
cnt     set     0x08
data_1  set     0x10
data_2  set     0x11
data_3  set     0x12
data_4  set     0x13

w       equ     0
f       equ     1

;definice bitu

	org     0
	goto	init

	org	1B1
init    movlw   b'00000001'     ; nastaveni GPIO
	movwf   gpio
	movlw   b'11111110'     ; 0-vystup 1,2,3-vstup
	tris    gpio
				; hlavni program
	call    wait    	; cekej 100 ms a vysilej nosnou
strt_1  movlw   .80		; vysilej nosnou 30 ms
	movwf   cnt
	call    w_1
strt_2	movlw   znak_1  	; priprav data k vysilani
	movwf   data_1
	movlw   znak_2
	movwf   data_2
	movlw   znak_3
	movwf   data_3
	movlw   znak_4
	movwf   data_4
	movlw	data_1
	movwf	fsr
	clrw			; startbit_1
	call    outstp
	nop
	call    outstr		; bit_0
	call    out		; bit_1
	call    out		; bit_2
	call    out		; bit_3
	call    out		; bit_4	
	call    out		; bit_5
	call    out		; bit_6
	call    out		; bit_7
	movlw	1		; stopbit
	nop
	call    outstp
	incf	fsr,f		; startbit_2
	clrw	
	call    outstp
	nop
	call    outstr		; bit_0
	call    out		; bit_1
	call    out		; bit_2
	call    out		; bit_3
	call    out		; bit_4
	call    out		; bit_5
	call    out		; bit_6
	call    out		; bit_7
	movlw	1		; stopbit
	nop
	call    outstp
	incf	fsr,f		; startbit_3
	clrw	
	call    outstp
	nop
	call    outstr		; bit_0
	call    out		; bit_1
	call    out		; bit_2
	call    out		; bit_3
	call    out		; bit_4
	call    out		; bit_5
	call    out		; bit_6
	call    out		; bit_7
	movlw	1		; stopbit
	nop
	call    outstp
	incf	fsr,f		; startbit_4
	clrw		
	call    outstp
	nop
	call    outstr		; bit_0
	call    out		; bit_1
	call    out		; bit_2
	call    out		; bit_3
	call    out		; bit_4
	call    out		; bit_5
	call    out		; bit_6
	call    out		; bit_7
	movlw	1		; stopbit
	nop
	call    outstp
	goto    strt_1

	org	0F7
;------------
out	rrf	indf,f
outstr	movfw	indf
outstp	andlw	1
xx	movwf	gpio
	retlw	0
;------------
wait    clrf	cnt
w_1 	decfsz  cnt,f
	goto    w_1
	retlw   0
;------------
	end
